



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Oracle  触发器，事物</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Oracle  触发器，事物</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 21:15:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>触发器：自动执行，可以实现表的约束。</p></blockquote>
<p>1.行级触发器：　　</p>
<div>
<pre class="prettyprint linenums">CREATE OR REPLACE TRIGGER del_deptid<br />
AFTER DELETE ON  deptment        --触发器条件 DELETE动作<br />
FOR EACH ROW                     --循环每一行都改<br />
BEGIN<br />
DELETE FROM emp WHERE id=:old.id; --触发后动作<br />
END del_deptid;         --END;都行<br />
/    </pre>
</div>
<div>
<pre class="prettyprint linenums">DELETE FROM deptment WHERE id='';  --触发触发器</pre>
</div>
<div>
<pre class="prettyprint linenums">CREATE OR REPLACE TRIGGER insert_dept<br />
AFTER INSERT ON  deptment        --触发器条件 INSERT动作<br />
FOR EACH ROW                     --循环每一行都改<br />
BEGIN<br />
INSERT INTO emp(eid ,ename,id) VALUES('','qwer',:new.id); --触发后动作<br />
END;<br />
/ </pre>
</div>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td>old</td>
<td>new</td>
</tr>
<tr>
<td>insert</td>
<td>n</td>
<td>y</td>
</tr>
<tr>
<td>delete</td>
<td>y</td>
<td>n</td>
</tr>
<tr>
<td>update</td>
<td>y</td>
<td>y</td>
</tr>
</tbody>
</table>
<p>n为不涉及的</p>
<p>只有在创建触发器的时候会触及oracle的old和new逻辑表，old和new是oracle在内存中建立的表，表的字段结构和触发器所涉及的表的字段结构一致，对表操作时，先将要修改的内容保存在old和new中，commit后写到磁盘中，如删除表中的一条的数据，先将内存中该表的该条数据移动到old表中，插入是将要插入的数据先插入到new中，之后再插入到内存表中，更新是将where后的信息存入old，将set红的数据存入new中，其他不变字段就一样。</p>
<blockquote><p>利用old和new表做级联更新：</p></blockquote>
<div>
<pre class="prettyprint linenums">CREATE OR REPLACE TRIGGER update_dept<br />
AFTER UPDATE ON deptment<br />
FOR EACH ROW<br />
BEGIN<br />
UPDATE emp SET id=:new.id WHERE id=:old.id;<br />
END;<br />
/          --不可以在语句块中写commit 和 rollback</pre>
</div>
<div>
<pre class="prettyprint linenums">UPDATE deptment SET id='yy' WHERE id='';</pre>
</div>
<div>
<pre class="prettyprint linenums">CREATE OR REPLACE TRIGGER book_delete<br />
AFTER DELETE ON books<br />
FOR EACH ROW<br />
BEGIN<br />
IF :old.books_id='' THEN                     --通过触发器实现控制<br />
RAISE_APPLICATION_ERROR(-20000,'不允许删除！');    ---2000为错误代码<br />
END IF;<br />
END;<br />
/</pre>
</div>
<p>2.语句级触发器：</p>
<div>
<pre class="prettyprint linenums">CREATE OR REPLACE TRIGGER dml_aa<br />
AFTER INSERT OR DELETE OR UPDATE         --可以是多个动作触发<br />
BEGIN                                       --没有for each row 没有数据完整性约束<br />
IF INSERTING THEN<br />
INSERT INTO mylog VALUES(user,sysdate,'I');<br />
ELSIF DELETING THEN<br />
INSERT INTO mylog VALUES(user,sysdate,'D');<br />
ELSE<br />
INSERT INTO mylog VALUES(user,sysdate,'U');<br />
END IF;<br />
END;<br />
/</pre>
</div>
<p>3.利用触发器实现表中整型字段的自增：</p>
<div>
<pre class="prettyprint linenums">CREATE OR REPLACE TRIGGER set_no<br />
BEFORE INSERT ON auto              --前触发器，插入之前做一个预处理<br />
FOR EACH ROW<br />
DECLARE<br />
sn number(5);  --定义变量<br />
BEGIN<br />
SELECT myseq.nextval INTO sn FROM dual;--取出myseq序列的值，放入变量中<br />
:NEW.a:=sn;          --插入前，将sn的值赋给表中的a字段，NEW为触发器在内存中自动生成的和要处理的表字段结构一致的表，即auto表中的a字段，如果用向a字段。<br />
END;<br />
/</pre>
</div>
<p>4.替换触发器：</p>
<p>有的视图是由两个表组成的，当视图是由两个或两个以上组成的是不允许同时更新的，而替换触发器可以解决这种视图的多表更新的，替换触发器在Oracle中只能建在视图上。</p>
<p>视图建立在员工表和部门表上，v_emp_dept；</p>
<p>当向视图中插入数据时会提示，每次只能更改一个表中的信息，用替换触发器解决此问题的方法。</p>
<div>
<pre class="prettyprint linenums">CREATE OR REPLACE TRIGGER tr_v_e_d<br />
INSTEAD OF INSERT ON v_emp_dept --替换向v_emp_dept 视图中插入数据的方法，分别向两个表中插入数据实现<br />
FOR EACH ROW                      --替换触发器是特别的行触发器<br />
BEGIN<br />
INSERT INTO deptment VALUES(:new.id,:new.name);<br />
INSERT INTO emp(eid,ename,sex,id) VALUES(:new.eid,:new.ename,:new.sex,:new.id);<br />
END;<br />
/</pre>
</div>
<blockquote><p>事物</p></blockquote>
<p>修改表的时候如果不 commit 是不会修改的，虽然用查询语句查询会出现该条记录已被修改，但只是在内存中修改，用 rollback命令即可还原，只要没commit就没有修改该表。commit 是将内存中的数据写到磁盘上，rollback命令可还原上一个动作的的修改，一旦commit之后，就不可以rollback回来了，rollback之后也不可以commit了。</p>
<div>SELECT * FROM &nbsp;dept FOR UPDATE;</div>
<div>这样在其他用户下就不可以修改该表，直到你修改之后，commit，别人才可以改，像是买票那个锁。</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8znl18y.html">使用session页面控制登录入口及购物车效果的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93dodz8.html">C语言中static的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdo6xv8.html">安全协议系列（四）----SSL与TLS</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mz3mkq.html">Canvas 获取颜色值</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yjzl5q.html">MySQL索引背后的数据结构及算法原理 --转</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdewwnx9.html">js&comma;jquery概念理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yp530q.html">Mysql账号管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdyvnd8.html">Unable to execute dex&colon; Multiple dex files define 解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mpxmeq.html">java后台开发- NOTE</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eye32x9.html">和S5933比较起来，开发PLX9054比较不幸，可能是第一次开发PCI的缘故吧。因为，很多PCI的例子都是对S5933，就连微软出版的《Programming the Microsoft Windows Driver Model》都提供了一个完整的S5933的例子。 在这篇有关DDK的开发论文里。</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j661v8.html">解决报错：IncompleteElementException&colon; Could not find result map&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jndo38.html">jq实现碰到边缘反弹的动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkj3j08.html">scrapy安装教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j10xel9.html">spring-aop思想实践demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/960mzoy9.html">PLSQL 错误问题：Datebase character set &lpar;AL32UTF-8&rpar; and Client character set &lpar;ZHS16GBK&rpar; are different&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvdoex8.html">Android assets res 文件夹的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r501d7q.html">Confluence 6 修改 Home 目录的位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gwepmq.html">Kubernetes 1&period;12公布：Kubelet TLS Bootstrap与Azure虚拟机规模集（VMSS）迎来通用版本号</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jenvjq.html">&lbrack;Golang&rsqb; 第三方包应该如何安装--在线和离线</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppm2jk9.html">Spark学习笔记--Linux安装Spark集群详解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e11zxm9.html">ext afteredit</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ooxpv9.html">jQuery实现图片延迟加载</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmjeee9.html">caches 文件夹删除</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdjkzy8.html">IT公司100题-6-根据上排给出十个数，在其下排填出对应的十个数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdep02x9.html">IE7的overflow失效的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/96opodj9.html">MyEclipse8&period;5集成Tomcat7</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv1111q.html">DotNetBar v12&period;6&period;0&period;4 Fully Cracked</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmjjxk9.html">ie浏览器兼容性快速处理小招</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1pp669.html">C&plus;&plus;指针详解（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mzonjq.html">SharePoint 2013 Nintex Workflow 工作流帮助（八）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
